import java.io.*;

public class DemoFile
{
    public static void main(String[] args) throws IOException {
        File file = new File("folder/subfolder/../subfolder/file.txt");
        // or:
        File f = new File("folder");
        f = new File(f, "subfolder");
        f = new File(f, "file.txt");
        
        System.out.println("file exists? " + file.exists());
        
        System.out.println(file.getAbsoluteFile());
        System.out.println(file.getAbsolutePath());
        System.out.println(file.getCanonicalFile());
        System.out.println(file.getCanonicalPath());
    }
    
    
    public static void dirDemo() {
        File dir = new File("folder/subfolder");
        
        for (String f: dir.list()) {
            System.out.println(f);
        }
    }
    
    public static void dirDemoWithFiltering() {
        File dir = new File("folder/subfolder");
        
        for (File f: dir.listFiles(new MyFilter())) {
            System.out.println(f);
        }
    }
    
    public static void dirDemoWithFiltering2() {
        File dir = new File("folder/subfolder");
        
        File[] list = dir.listFiles(
            new FileFilter() {
                public boolean accept(File f) {
                    return f.getPath().endsWith(".txt");
                }
            }
        );
        
        for (File f: list) {
            System.out.println(f);
        }
    }
    
    public static void dirDemoWithFiltering3() {
        File dir = new File("folder/subfolder");
        
        for (File f: dir.listFiles(ff -> ff.getPath().endsWith(".txt"))) {
            System.out.println(f);
        }
    }
}
